import java.util.function.Supplier;
import java.util.stream.Stream;

public class Main {

    public static final int MILLION = 1_000_000;

    public static void main(String[] args) {
        // С помощью данного стрима мы находим первое число Фибоначчи большее 1000000
        Stream.generate(new SupplierFibonacci())
                .filter(v -> v > MILLION) // находим числа большие 1000000
                .limit(1) // берем первое из них
                .forEach(System.out::println);
    }

    /**
     * Класс для получения очередного числа Фибоначчи
     */
    private static class SupplierFibonacci implements Supplier<Integer> {

        private int prev = 0;
        private int next = 1;

        @Override
        public Integer get() {
            int current = next;

            next += prev;
            prev = current;

            return current;
        }
    }
}
